<template>
  <div>
    <rui-actions>
      <rui-button icon="plus"
                  :caption="$t('js.harvests.element_harvests.new_harvest')"
                  variant="creative"
                  @click="$emitBus('show-harvest-form', element)" />
    </rui-actions>
    <div class="_container">
      <rui-loading v-if="loading" />
      <rui-errors v-else-if="loadingError" :errors="loadingError" />
      <rui-empty v-else-if="harvests.length === 0" :content="$t('js.harvests.element_harvests.no_record_yet')" />
      <div v-else>
        <h3>{{ $t('js.generic.total') }}</h3>
        <ul>
          <li v-for="(value, key) in totals" :key="key">
            {{ value }} {{ $t(`js.unit.${key}`, {count: value}) }}
          </li>
        </ul>

        <h3>{{ $t('js.harvests.element_harvests.already_harvested') }}</h3>
        <table>
          <thead>
            <tr>
              <th>{{ $t('generic.date') }}</th>
              <th>{{ $t('activerecord.attributes.harvest.quantity') }}</th>
              <th>{{ $t('activerecord.attributes.harvest.unit') }}</th>
              <th />
            </tr>
          </thead>
          <tbody>
            <tr v-for="(harvest, index) in harvests" :key="harvest.id">
              <td>{{ $d(harvest.harvestedAt, 'date') }} </td>
              <td>{{ harvestsValues[index].value }}</td>
              <td>{{ $t(`js.unit.${harvestsValues[index].unit}`, {count: harvestsValues[index].value}) }}</td>
              <td class="-actions">
                <rui-toolbar>
                  <rui-button variant="destructive" icon="trash" :title="$t('generic.destroy')" @click="destroy(harvest)" />
                  <rui-button variant="creative" icon="pencil" :title="$t('generic.edit')" @click="$emitBus('show-harvest-form', harvest)" />
                </rui-toolbar>
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
  </div>
</template>

<script>
import RuiActions from '@experiments-labs/rise_ui/src/components/Actions/Actions.vue'
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiEmpty from '@experiments-labs/rise_ui/src/components/DataDisplay/Empty/Empty.vue'
import RuiErrors from '@experiments-labs/rise_ui/src/components/DataDisplay/Error/Errors.vue'
import RuiLoading from '@experiments-labs/rise_ui/src/components/Loading/Loading.vue'
import RuiToolbar from '@experiments-labs/rise_ui/src/components/Toolbar/Toolbar.vue'

import { convertUnit } from '@/helpers/Units'
import Toaster from '@/vue/tools/Toaster'
import Element from '../../../../classes/models/Element'

export default {
  name: 'GpaElementHarvests',
  emits: [
    'cancel',
    'done',
  ],
  components: { RuiToolbar, RuiEmpty, RuiLoading, RuiErrors, RuiButton, RuiActions },
  props: {
    element: { required: true, type: Element },
  },
  data () {
    return {
      loading: false,
      loadingError: null,
      editedHarvest: null,
    }
  },
  computed: {
    harvests () { return this.$store.getters.harvestsForElement(this.element.id) },
    harvestsValues () { return this.harvests.map(h => convertUnit(h.quantity, h.unit)) },
    totals () {
      const totals = {}
      this.harvests.forEach(h => {
        if (!totals[h.unit]) totals[h.unit] = 0
        totals[h.unit] += h.quantity
      })

      const converted = {}
      Object.keys(totals).forEach((unit) => {
        const pair = convertUnit(totals[unit], unit)
        converted[pair.unit] = pair.value
      })

      return converted
    },
  },
  methods: {
    loadHarvests () {
      this.loading = true
      this.error = false
      this.$store.dispatch('loadElementHarvests', this.element.id)
        .catch((error) => { this.loadingError = error })
        .then(() => { this.loading = false })
    },
    destroy (harvest) {
      this.$emitBus('ask-confirmation', {
        caption: this.$t('js.harvest.destroy_warning_title'),
        message: this.$t('js.harvest.destroy_warning'),
        callback: () => {
          this.$store.dispatch('destroyHarvest', harvest.id)
            .then(() => { Toaster.success(this.$t('js.harvest.successfully_destroyed')) })
            .catch(() => { Toaster.error(this.$t('js.harvest.failed_to_destroy')) })
        },
      })
    },
  },
  created () {
    this.loadHarvests()
  },
  watch: {
    element () {
      this.loadHarvests()
    },
  },
}
</script>
